/*
	HighscoreView.h
	Copyright 1996-1997 Be Do Have Software. All Rights Reserved.
*/
#ifndef BDH_HIGHSCOREVIEW_H
#define BDH_HIGHSCOREVIEW_H 1

#include <Font.h>
#include <List.h>
#include <stdio.h>
#include "TextGridView.h"

//------------------------------------------
// Standard shared library gibberish
#include "BdhBuild.h"
#undef _EXPIMP
#if _BUILDING_BdhGame + 0 > 0
#define _EXPIMP	_EXPORT
#else
#define _EXPIMP	_IMPORT
#endif

#if __POWERPC__ 
#pragma export on
#endif
//------------------------------------------


// view containing high score information
class _EXPIMP HighscoreView : public TextGridView {
public:
	HighscoreView( const uint16 columns, const uint16 rows,
		const BFont *font, const BPoint offset, const char* title,
		const char* scoreFileName, const char* firstline = NULL );
	~HighscoreView();
	virtual void Draw( BRect );
	void	AttachedToWindow(void);
	virtual void MessageReceived( BMessage* );
	virtual void alertScore( uint32 score );
	void  addHighScore( uint32 score, const char *scorer );
protected:
	void  fillHistory( BFile* );
	void  promptScorer( uint32 score );
private:
	int		getline( BFile *fp, char *buffer, int bufSize );
private:
	char	*scoreFn;
	char	*firstLine;
	BList*	historyList;
	int16	listMax;
	int		errorNum;
};

// BMessage reply from HighscoreView::promptScorer()
#define SCORE_VIEW_PROMPTED		'.SvP'

#if __POWERPC__ 
#pragma export off
#endif
#endif // BDH_HIGHSCOREVIEW_H
